import{s as ya,n as ba,o as fa}from"../chunks/scheduler.362310b7.js";import{S as va,i as wa,g as i,s as n,r as c,m as B,H as F,A as xa,h as p,f as t,c as l,j as Ns,u,x as m,n as D,B as O,k as oa,y as V,a as e,v as g,d,t as y,w as b}from"../chunks/index.57dfc70d.js";import{C as K}from"../chunks/CodeBlock.d3c47f83.js";import{H as Ss,E as za}from"../chunks/EditOnGithub.9633c464.js";function Ta(Es){let h,ss,R,as,f,ts,v,As="TGI offers many quantization schemes to run LLMs effectively and fast based on your use-case. TGI supports GPTQ, AWQ, bits-and-bytes, EETQ, Marlin, EXL2 and fp8 quantization.",es,w,Vs="To leverage GPTQ, AWQ, Marlin and EXL2 quants, you must provide pre-quantized weights. Whereas for bits-and-bytes, EETQ and fp8, weights are quantized by TGI on the fly.",ns,x,Rs="We recommend using the official quantization scripts for creating your quants:",ls,z,Ys='<li><a href="https://github.com/casper-hansen/AutoAWQ/blob/main/examples/quantize.py" rel="nofollow">AWQ</a></li> <li><a href="https://github.com/AutoGPTQ/AutoGPTQ/blob/main/examples/quantization/basic_usage.py" rel="nofollow">GPTQ/ Marlin</a></li> <li><a href="https://github.com/turboderp/exllamav2/blob/master/doc/convert.md" rel="nofollow">EXL2</a></li>',is,T,Bs="For on-the-fly quantization you simply need to pass one of the supported quantization types and TGI takes care of the rest.",ps,M,ms,G,Fs="bitsandbytes is a library used to apply 8-bit and 4-bit quantization to models. Unlike GPTQ quantization, bitsandbytes doesn’t require a calibration dataset or any post-processing – weights are automatically quantized on load. However, inference with bitsandbytes is slower than GPTQ or FP16 precision.",rs,$,Ds=`8-bit quantization enables multi-billion parameter scale models to fit in smaller hardware without degrading performance too much.
In TGI, you can use 8-bit quantization by adding <code>--quantize bitsandbytes</code> like below 👇`,os,q,hs,L,Os="4-bit quantization is also possible with bitsandbytes. You can choose one of the following 4-bit data types: 4-bit float (<code>fp4</code>), or 4-bit <code>NormalFloat</code> (<code>nf4</code>). These data types were introduced in the context of parameter-efficient fine-tuning, but you can apply them for inference by automatically converting the model weights on load.",cs,_,Ks="In TGI, you can use 4-bit quantization by adding <code>--quantize bitsandbytes-nf4</code> or <code>--quantize bitsandbytes-fp4</code> like below 👇",us,C,gs,Z,sa='You can get more information about 8-bit quantization by reading this <a href="https://huggingface.co/blog/hf-bitsandbytes-integration" rel="nofollow">blog post</a>, and 4-bit quantization by reading <a href="https://huggingface.co/blog/4bit-transformers-bitsandbytes" rel="nofollow">this blog post</a>.',ds,W,aa="Similarly you can use pass you can pass <code>--quantize eetq</code> or <code>--quantize fp8</code> for respective quantization schemes.",ys,k,ta="In addition to this, TGI allows creating GPTQ quants directly by passing the model weights and a calibration dataset.",bs,J,fs,P,ea="GPTQ is a post-training quantization method to make the model smaller. It quantizes the layers by finding a compressed version of that weight, that will yield a minimum mean squared error like below 👇",vs,r,Xs,ws,ha='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mi>l</mi></mrow><annotation encoding="application/x-tex">l</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.6944em;"></span><span class="mord mathnormal" style="margin-right:0.01968em;">l</span></span></span></span>',xs,zs,ca='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>W</mi><mi>l</mi></msub></mrow><annotation encoding="application/x-tex">W_{l}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.13889em;">W</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.1389em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Ts,Ms,ua='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><msub><mi>X</mi><mi>l</mi></msub></mrow><annotation encoding="application/x-tex">X_{l}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:0.8333em;vertical-align:-0.15em;"></span><span class="mord"><span class="mord mathnormal" style="margin-right:0.07847em;">X</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.0785em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',Gs,$s,ga='<span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML"><semantics><mrow><mspace linebreak="newline"></mspace><mi>h</mi><mi>a</mi><mi>t</mi><msub><mi>W</mi><mi>l</mi></msub></mrow><annotation encoding="application/x-tex">\\\\hat{W}_{l}</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="mspace newline"></span><span class="base"><span class="strut" style="height:0.8444em;vertical-align:-0.15em;"></span><span class="mord mathnormal">ha</span><span class="mord mathnormal">t</span><span class="mord"><span class="mord"><span class="mord mathnormal" style="margin-right:0.13889em;">W</span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span></span></span>',qs,Ls,da='<span class="katex-display"><span class="katex"><span class="katex-mathml"><math xmlns="http://www.w3.org/1998/Math/MathML" display="block"><semantics><mrow><mo stretchy="false">(</mo><msup><msub><mover accent="true"><mi>W</mi><mo>^</mo></mover><mi>l</mi></msub><mo lspace="0em" rspace="0em">∗</mo></msup><mo>=</mo><mi>a</mi><mi>r</mi><mi>g</mi><mi>m</mi><mi>i</mi><msub><mi>n</mi><mover accent="true"><msub><mi>W</mi><mi>l</mi></msub><mo>^</mo></mover></msub><mi mathvariant="normal">∣</mi><mi mathvariant="normal">∣</mi><msub><mi>W</mi><mi>l</mi></msub><mi>X</mi><mo>−</mo><msub><mover accent="true"><mi>W</mi><mo>^</mo></mover><mi>l</mi></msub><mi>X</mi><mi mathvariant="normal">∣</mi><msubsup><mi mathvariant="normal">∣</mi><mn>2</mn><mn>2</mn></msubsup><mo stretchy="false">)</mo></mrow><annotation encoding="application/x-tex">({\\hat{W}_{l}}^{*} = argmin_{\\hat{W_{l}}} ||W_{l}X-\\hat{W}_{l}X||^{2}_{2})</annotation></semantics></math></span><span class="katex-html" aria-hidden="true"><span class="base"><span class="strut" style="height:1.2754em;vertical-align:-0.25em;"></span><span class="mopen">(</span><span class="mord"><span class="mord"><span class="mord"><span class="mord accent"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.9468em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">W</span></span><span style="top:-3.2523em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.25em;"><span class="mord">^</span></span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.1389em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span></span><span class="msupsub"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:1.0254em;"><span style="top:-3.3997em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">∗</span></span></span></span></span></span></span></span></span><span class="mspace" style="margin-right:0.2778em;"></span><span class="mrel">=</span><span class="mspace" style="margin-right:0.2778em;"></span></span><span class="base"><span class="strut" style="height:1.1738em;vertical-align:-0.4238em;"></span><span class="mord mathnormal">a</span><span class="mord mathnormal" style="margin-right:0.02778em;">r</span><span class="mord mathnormal" style="margin-right:0.03588em;">g</span><span class="mord mathnormal">mi</span><span class="mord"><span class="mord mathnormal">n</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3448em;"><span style="top:-2.3821em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord accent mtight"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.9468em;"><span style="top:-2.7em;"><span class="pstrut" style="height:2.7em;"></span><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.13889em;">W</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3448em;"><span style="top:-2.3488em;margin-left:-0.1389em;margin-right:0.0714em;"><span class="pstrut" style="height:2.5em;"></span><span class="sizing reset-size3 size1 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1512em;"><span></span></span></span></span></span></span></span><span style="top:-2.9523em;"><span class="pstrut" style="height:2.7em;"></span><span class="accent-body" style="left:-0.25em;"><span class="mord mtight">^</span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.1512em;"><span></span></span></span></span></span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.4238em;"><span></span></span></span></span></span></span><span class="mord">∣∣</span><span class="mord"><span class="mord mathnormal" style="margin-right:0.13889em;">W</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.1389em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.07847em;">X</span><span class="mspace" style="margin-right:0.2222em;"></span><span class="mbin">−</span><span class="mspace" style="margin-right:0.2222em;"></span></span><span class="base"><span class="strut" style="height:1.1968em;vertical-align:-0.25em;"></span><span class="mord"><span class="mord accent"><span class="vlist-t"><span class="vlist-r"><span class="vlist" style="height:0.9468em;"><span style="top:-3em;"><span class="pstrut" style="height:3em;"></span><span class="mord mathnormal" style="margin-right:0.13889em;">W</span></span><span style="top:-3.2523em;"><span class="pstrut" style="height:3em;"></span><span class="accent-body" style="left:-0.25em;"><span class="mord">^</span></span></span></span></span></span></span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.3361em;"><span style="top:-2.55em;margin-left:-0.1389em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mathnormal mtight" style="margin-right:0.01968em;">l</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.15em;"><span></span></span></span></span></span></span><span class="mord mathnormal" style="margin-right:0.07847em;">X</span><span class="mord">∣</span><span class="mord"><span class="mord">∣</span><span class="msupsub"><span class="vlist-t vlist-t2"><span class="vlist-r"><span class="vlist" style="height:0.8641em;"><span style="top:-2.453em;margin-left:0em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span><span style="top:-3.113em;margin-right:0.05em;"><span class="pstrut" style="height:2.7em;"></span><span class="sizing reset-size6 size3 mtight"><span class="mord mtight"><span class="mord mtight">2</span></span></span></span></span><span class="vlist-s">​</span></span><span class="vlist-r"><span class="vlist" style="height:0.247em;"><span></span></span></span></span></span></span><span class="mclose">)</span></span></span></span></span>',_s,H,na='TGI allows you to both run an already GPTQ quantized model (see available models <a href="https://huggingface.co/models?search=gptq" rel="nofollow">here</a>) or quantize a model of your choice using quantization script. You can run a quantized model by simply passing —quantize like below 👇',Cs,I,Zs,Q,la='Note that TGI’s GPTQ implementation doesn’t use <a href="https://github.com/PanQiWei/AutoGPTQ" rel="nofollow">AutoGPTQ</a> under the hood. However, models quantized using AutoGPTQ or Optimum can still be served by TGI.',Ws,U,ia="To quantize a given model using GPTQ with a calibration dataset, simply run",ks,j,Js,X,pa="This will create a new directory with the quantized files which you can use with,",Ps,N,Hs,S,ma="You can learn more about the quantization options by running <code>text-generation-server quantize --help</code>.",Is,E,ra=`If you wish to do more with GPTQ models (e.g. train an adapter on top), you can read about transformers GPTQ integration <a href="https://huggingface.co/blog/gptq-integration" rel="nofollow">here</a>.
You can learn more about GPTQ from the <a href="https://arxiv.org/pdf/2210.17323.pdf" rel="nofollow">paper</a>.`,Qs,A,Us,Y,js;return f=new Ss({props:{title:"Quantization",local:"quantization",headingTag:"h1"}}),M=new Ss({props:{title:"Quantization with bitsandbytes, EETQ & fp8",local:"quantization-with-bitsandbytes-eetq--fp8",headingTag:"h2"}}),q=new K({props:{code:"ZG9ja2VyJTIwcnVuJTIwLS1ncHVzJTIwYWxsJTIwLS1zaG0tc2l6ZSUyMDFnJTIwLXAlMjA4MDgwJTNBODAlMjAtdiUyMCUyNHZvbHVtZSUzQSUyRmRhdGElMjBnaGNyLmlvJTJGaHVnZ2luZ2ZhY2UlMkZ0ZXh0LWdlbmVyYXRpb24taW5mZXJlbmNlJTNBbGF0ZXN0JTIwLS1tb2RlbC1pZCUyMCUyNG1vZGVsJTIwLS1xdWFudGl6ZSUyMGJpdHNhbmRieXRlcw==",highlighted:'docker run --gpus all --shm-size 1g -p 8080:80 -v <span class="hljs-variable">$volume</span>:/data ghcr.io/huggingface/text-generation-inference:latest --model-id <span class="hljs-variable">$model</span> --quantize bitsandbytes',wrap:!1}}),C=new K({props:{code:"ZG9ja2VyJTIwcnVuJTIwLS1ncHVzJTIwYWxsJTIwLS1zaG0tc2l6ZSUyMDFnJTIwLXAlMjA4MDgwJTNBODAlMjAtdiUyMCUyNHZvbHVtZSUzQSUyRmRhdGElMjBnaGNyLmlvJTJGaHVnZ2luZ2ZhY2UlMkZ0ZXh0LWdlbmVyYXRpb24taW5mZXJlbmNlJTNBbGF0ZXN0JTIwLS1tb2RlbC1pZCUyMCUyNG1vZGVsJTIwLS1xdWFudGl6ZSUyMGJpdHNhbmRieXRlcy1uZjQ=",highlighted:'docker run --gpus all --shm-size 1g -p 8080:80 -v <span class="hljs-variable">$volume</span>:/data ghcr.io/huggingface/text-generation-inference:latest --model-id <span class="hljs-variable">$model</span> --quantize bitsandbytes-nf4',wrap:!1}}),J=new Ss({props:{title:"Quantization with GPTQ",local:"quantization-with-gptq",headingTag:"h2"}}),I=new K({props:{code:"ZG9ja2VyJTIwcnVuJTIwLS1ncHVzJTIwYWxsJTIwLS1zaG0tc2l6ZSUyMDFnJTIwLXAlMjA4MDgwJTNBODAlMjAtdiUyMCUyNHZvbHVtZSUzQSUyRmRhdGElMjBnaGNyLmlvJTJGaHVnZ2luZ2ZhY2UlMkZ0ZXh0LWdlbmVyYXRpb24taW5mZXJlbmNlJTNBbGF0ZXN0JTIwLS1tb2RlbC1pZCUyMCUyNG1vZGVsJTIwLS1xdWFudGl6ZSUyMGdwdHE=",highlighted:'docker run --gpus all --shm-size 1g -p 8080:80 -v <span class="hljs-variable">$volume</span>:/data ghcr.io/huggingface/text-generation-inference:latest --model-id <span class="hljs-variable">$model</span> --quantize gptq',wrap:!1}}),j=new K({props:{code:"dGV4dC1nZW5lcmF0aW9uLXNlcnZlciUyMHF1YW50aXplJTIwdGlpdWFlJTJGZmFsY29uLTQwYiUyMCUyRmRhdGElMkZmYWxjb24tNDBiLWdwdHElMEElMjMlMjBBZGQlMjAtLXVwbG9hZC10by1tb2RlbC1pZCUyME1ZVVNFUk5BTUUlMkZmYWxjb24tNDBiJTIwdG8lMjBwdXNoJTIwdGhlJTIwY3JlYXRlZCUyMG1vZGVsJTIwdG8lMjB0aGUlMjBodWIlMjBkaXJlY3RseQ==",highlighted:`text-generation-server quantize tiiuae/falcon-40b /data/falcon-40b-gptq
<span class="hljs-comment"># Add --upload-to-model-id MYUSERNAME/falcon-40b to push the created model to the hub directly</span>`,wrap:!1}}),N=new K({props:{code:"dGV4dC1nZW5lcmF0aW9uLWxhdW5jaGVyJTIwLS1tb2RlbC1pZCUyMCUyRmRhdGElMkZmYWxjb24tNDBiLWdwdHElMkYlMjAtLXNoYXJkZWQlMjB0cnVlJTIwLS1udW0tc2hhcmQlMjAyJTIwLS1xdWFudGl6ZSUyMGdwdHE=",highlighted:'text-generation-launcher --model-id /data/falcon-40b-gptq/ --sharded <span class="hljs-literal">true</span> --num-shard 2 --quantize gptq',wrap:!1}}),A=new za({props:{source:"https://github.com/huggingface/text-generation-inference/blob/main/docs/source/conceptual/quantization.md"}}),{c(){h=i("meta"),ss=n(),R=i("p"),as=n(),c(f.$$.fragment),ts=n(),v=i("p"),v.textContent=As,es=n(),w=i("p"),w.textContent=Vs,ns=n(),x=i("p"),x.textContent=Rs,ls=n(),z=i("ol"),z.innerHTML=Ys,is=n(),T=i("p"),T.textContent=Bs,ps=n(),c(M.$$.fragment),ms=n(),G=i("p"),G.textContent=Fs,rs=n(),$=i("p"),$.innerHTML=Ds,os=n(),c(q.$$.fragment),hs=n(),L=i("p"),L.innerHTML=Os,cs=n(),_=i("p"),_.innerHTML=Ks,us=n(),c(C.$$.fragment),gs=n(),Z=i("p"),Z.innerHTML=sa,ds=n(),W=i("p"),W.innerHTML=aa,ys=n(),k=i("p"),k.textContent=ta,bs=n(),c(J.$$.fragment),fs=n(),P=i("p"),P.textContent=ea,vs=n(),r=i("p"),Xs=B("Given a layer"),ws=new F(!1),xs=B(" with weight matrix"),zs=new F(!1),Ts=B(" and layer input"),Ms=new F(!1),Gs=B(", find quantized weight"),$s=new F(!1),qs=B(`:
`),Ls=new F(!1),_s=n(),H=i("p"),H.innerHTML=na,Cs=n(),c(I.$$.fragment),Zs=n(),Q=i("p"),Q.innerHTML=la,Ws=n(),U=i("p"),U.textContent=ia,ks=n(),c(j.$$.fragment),Js=n(),X=i("p"),X.textContent=pa,Ps=n(),c(N.$$.fragment),Hs=n(),S=i("p"),S.innerHTML=ma,Is=n(),E=i("p"),E.innerHTML=ra,Qs=n(),c(A.$$.fragment),Us=n(),Y=i("p"),this.h()},l(s){const a=xa("svelte-u9bgzb",document.head);h=p(a,"META",{name:!0,content:!0}),a.forEach(t),ss=l(s),R=p(s,"P",{}),Ns(R).forEach(t),as=l(s),u(f.$$.fragment,s),ts=l(s),v=p(s,"P",{"data-svelte-h":!0}),m(v)!=="svelte-1uhon0f"&&(v.textContent=As),es=l(s),w=p(s,"P",{"data-svelte-h":!0}),m(w)!=="svelte-m25niz"&&(w.textContent=Vs),ns=l(s),x=p(s,"P",{"data-svelte-h":!0}),m(x)!=="svelte-1uq49rw"&&(x.textContent=Rs),ls=l(s),z=p(s,"OL",{"data-svelte-h":!0}),m(z)!=="svelte-1fjxs52"&&(z.innerHTML=Ys),is=l(s),T=p(s,"P",{"data-svelte-h":!0}),m(T)!=="svelte-dlxq44"&&(T.textContent=Bs),ps=l(s),u(M.$$.fragment,s),ms=l(s),G=p(s,"P",{"data-svelte-h":!0}),m(G)!=="svelte-aqqk8a"&&(G.textContent=Fs),rs=l(s),$=p(s,"P",{"data-svelte-h":!0}),m($)!=="svelte-ktr7x0"&&($.innerHTML=Ds),os=l(s),u(q.$$.fragment,s),hs=l(s),L=p(s,"P",{"data-svelte-h":!0}),m(L)!=="svelte-1kt0l3g"&&(L.innerHTML=Os),cs=l(s),_=p(s,"P",{"data-svelte-h":!0}),m(_)!=="svelte-113ygv"&&(_.innerHTML=Ks),us=l(s),u(C.$$.fragment,s),gs=l(s),Z=p(s,"P",{"data-svelte-h":!0}),m(Z)!=="svelte-bx1jaz"&&(Z.innerHTML=sa),ds=l(s),W=p(s,"P",{"data-svelte-h":!0}),m(W)!=="svelte-17aol0b"&&(W.innerHTML=aa),ys=l(s),k=p(s,"P",{"data-svelte-h":!0}),m(k)!=="svelte-1likkzk"&&(k.textContent=ta),bs=l(s),u(J.$$.fragment,s),fs=l(s),P=p(s,"P",{"data-svelte-h":!0}),m(P)!=="svelte-aix1yq"&&(P.textContent=ea),vs=l(s),r=p(s,"P",{});var o=Ns(r);Xs=D(o,"Given a layer"),ws=O(o,!1),xs=D(o," with weight matrix"),zs=O(o,!1),Ts=D(o," and layer input"),Ms=O(o,!1),Gs=D(o,", find quantized weight"),$s=O(o,!1),qs=D(o,`:
`),Ls=O(o,!1),o.forEach(t),_s=l(s),H=p(s,"P",{"data-svelte-h":!0}),m(H)!=="svelte-14up0yw"&&(H.innerHTML=na),Cs=l(s),u(I.$$.fragment,s),Zs=l(s),Q=p(s,"P",{"data-svelte-h":!0}),m(Q)!=="svelte-14lnxb8"&&(Q.innerHTML=la),Ws=l(s),U=p(s,"P",{"data-svelte-h":!0}),m(U)!=="svelte-1drv0r"&&(U.textContent=ia),ks=l(s),u(j.$$.fragment,s),Js=l(s),X=p(s,"P",{"data-svelte-h":!0}),m(X)!=="svelte-f1w88s"&&(X.textContent=pa),Ps=l(s),u(N.$$.fragment,s),Hs=l(s),S=p(s,"P",{"data-svelte-h":!0}),m(S)!=="svelte-32p5y6"&&(S.innerHTML=ma),Is=l(s),E=p(s,"P",{"data-svelte-h":!0}),m(E)!=="svelte-a14ru9"&&(E.innerHTML=ra),Qs=l(s),u(A.$$.fragment,s),Us=l(s),Y=p(s,"P",{}),Ns(Y).forEach(t),this.h()},h(){oa(h,"name","hf:doc:metadata"),oa(h,"content",Ma),ws.a=xs,zs.a=Ts,Ms.a=Gs,$s.a=qs,Ls.a=null},m(s,a){V(document.head,h),e(s,ss,a),e(s,R,a),e(s,as,a),g(f,s,a),e(s,ts,a),e(s,v,a),e(s,es,a),e(s,w,a),e(s,ns,a),e(s,x,a),e(s,ls,a),e(s,z,a),e(s,is,a),e(s,T,a),e(s,ps,a),g(M,s,a),e(s,ms,a),e(s,G,a),e(s,rs,a),e(s,$,a),e(s,os,a),g(q,s,a),e(s,hs,a),e(s,L,a),e(s,cs,a),e(s,_,a),e(s,us,a),g(C,s,a),e(s,gs,a),e(s,Z,a),e(s,ds,a),e(s,W,a),e(s,ys,a),e(s,k,a),e(s,bs,a),g(J,s,a),e(s,fs,a),e(s,P,a),e(s,vs,a),e(s,r,a),V(r,Xs),ws.m(ha,r),V(r,xs),zs.m(ca,r),V(r,Ts),Ms.m(ua,r),V(r,Gs),$s.m(ga,r),V(r,qs),Ls.m(da,r),e(s,_s,a),e(s,H,a),e(s,Cs,a),g(I,s,a),e(s,Zs,a),e(s,Q,a),e(s,Ws,a),e(s,U,a),e(s,ks,a),g(j,s,a),e(s,Js,a),e(s,X,a),e(s,Ps,a),g(N,s,a),e(s,Hs,a),e(s,S,a),e(s,Is,a),e(s,E,a),e(s,Qs,a),g(A,s,a),e(s,Us,a),e(s,Y,a),js=!0},p:ba,i(s){js||(d(f.$$.fragment,s),d(M.$$.fragment,s),d(q.$$.fragment,s),d(C.$$.fragment,s),d(J.$$.fragment,s),d(I.$$.fragment,s),d(j.$$.fragment,s),d(N.$$.fragment,s),d(A.$$.fragment,s),js=!0)},o(s){y(f.$$.fragment,s),y(M.$$.fragment,s),y(q.$$.fragment,s),y(C.$$.fragment,s),y(J.$$.fragment,s),y(I.$$.fragment,s),y(j.$$.fragment,s),y(N.$$.fragment,s),y(A.$$.fragment,s),js=!1},d(s){s&&(t(ss),t(R),t(as),t(ts),t(v),t(es),t(w),t(ns),t(x),t(ls),t(z),t(is),t(T),t(ps),t(ms),t(G),t(rs),t($),t(os),t(hs),t(L),t(cs),t(_),t(us),t(gs),t(Z),t(ds),t(W),t(ys),t(k),t(bs),t(fs),t(P),t(vs),t(r),t(_s),t(H),t(Cs),t(Zs),t(Q),t(Ws),t(U),t(ks),t(Js),t(X),t(Ps),t(Hs),t(S),t(Is),t(E),t(Qs),t(Us),t(Y)),t(h),b(f,s),b(M,s),b(q,s),b(C,s),b(J,s),b(I,s),b(j,s),b(N,s),b(A,s)}}}const Ma='{"title":"Quantization","local":"quantization","sections":[{"title":"Quantization with bitsandbytes, EETQ & fp8","local":"quantization-with-bitsandbytes-eetq--fp8","sections":[],"depth":2},{"title":"Quantization with GPTQ","local":"quantization-with-gptq","sections":[],"depth":2}],"depth":1}';function Ga(Es){return fa(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ca extends va{constructor(h){super(),wa(this,h,Ga,Ta,ya,{})}}export{Ca as component};
